@echo off
:: SMAC ModManager v1.04 by #endgame
:: Run Mod Batchfile

:: Parameters
:: Run.bat [ModName] [-S]

:: [ModName] (Optional)
:: Specifies the name of the mod to launch
:: .SM extension is not required, looked for in
:: the Mods subdirectory. If not found, a list
:: of mods is presented.

:: [-S] (Optional)
:: Disable the splashscreen when running the mod.
:: Only works if [ModName] is specified and
:: -s -S /s /S are all accepted

set path=%path%;..;.\ModMan
set menu=

if not "%1"=="" goto run_arg

:: No arguments, build the menu.

:: Check that we actually have some mods

cd mods
for %%i in (*.SM) do set ismods=TRUE
cd ..

if not "%ismods%"=="TRUE" call w.bat box @gui.txt:no_mods
if not "%ismods%"=="TRUE" goto end

set ismods=

:: Since DOS doesn't have anything like
:: the *nix touch command, we make do by
:: typing a 0 byte file, since there is
:: a bug in the win9x version of COPY.

:: Because we use >, we don't need an
:: if exist check

type 0byte.txt>modlist.txt

cd Mods
for %%i in (*.SM) do command /E:4096 /C ..\add2list.bat %%i
cd ..

:: Display the list for the user

call w.bat list modlist.txt
del modlist.txt

:: Did they back out?

if "%wbat%"=="" goto end

set modtitle=%wbat%
set wbat=

:: Find out which mod it was

cd Mods
if exist Temp.bat del Temp.bat
echo @echo off>Temp.bat
for %%i in (*.SM) do call ChkTitle.bat %%i
call Temp.bat
set ModTitle=
del Temp.bat
cd ..

:: Smacmod.bat shouldn't ever exist here
:: unsupervised.

if exist smacmod.bat del smacmod.bat
copy Mods\%filename% .\smacmod.bat > NUL

goto launch

:: Argument Handling

:run_arg

if exist Mods\%1 set error=FALSE
if exist Mods\%1 set filename=%1
if exist Mods\%1.SM set error=FALSE
if exist Mods\%1.SM set filename=%1.SM

:: Did we find what we are looking for?

if "%error%"=="TRUE" call w.bat box @gui.txt:run_arg1_not_found
if "%error%"=="TRUE" goto end

set error=

:: Smacmod.bat shouldn't ever exist here
:: unsupervised.

if exist smacmod.bat del smacmod.bat
copy Mods\%filename% .\smacmod.bat > NUL

:: Determine if we are skipping the splashscreen

if "%2"=="-s" set nosplash=TRUE
if "%2"=="-S" set nosplash=TRUE
if "%2"=="/s" set nosplash=TRUE
if "%2"=="/S" set nosplash=TRUE

goto launch

:: Launching the beast

:launch

set filename=

copy /Y EchoOff.txt+smacmod.bat+Stub.txt smacmod2.bat > NUL

if not "%nosplash%"=="TRUE" echo call Splash.bat>>smacmod2.bat
if "%nosplash%"=="TRUE" set run=TRUE

set nosplash=

command /E:4096 /C smacmod2.bat

:: Get the user's choice from the splashscreen
:: (and the mod directory)
call temp.bat
del temp.bat
del smacmod.bat
del smacmod2.bat

if "%run%"=="FALSE" goto end
set run=

:: We are go for launch

cd ..

:: Long file names in for! woo!

lfnfor on > NUL
if not exist "%moddir%\Alpha Centauri.ini" copy "Alpha Centauri.ini" "%moddir%\Alpha Centauri.ini" > NUL
call swapin.bat %swaps%
call runsmac.bat
set exefile=
del "%moddir%\Alpha Centauri.ini" > NUL
copy "Alpha Centauri.ini" "%moddir%\Alpha Centauri.ini" > NUL
call swapout.bat %swaps%
set moddir=
set swaps=
cd ModMan
:end
set error=
set run=
set menu=Run